/*
    Xunzip for Linux, handles gzip and zip files via zlib.
    Copyright (C) 1998 Tero Koskinen

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 
*/
// xunzip.qt.tw.h (TestWindow class header)


#ifndef USE_GTK

#include <qapp.h>
#include <qpushbt.h>
#include <qfont.h>
#include <qlistbox.h>
#include <qlabel.h>
#include <qfiledlg.h>
#include <qframe.h>
#include <qlabel.h>

#include "zipheader.h"
#include "zippacket.h"

#ifndef TK_QT_TEST_W
#define TK_QT_TEST_W

class TestWindow: public QWidget
{
    Q_OBJECT
public:
    TestWindow(ZipPacket & zip,QWidget *parent=0,const char *name=0);
    ~TestWindow();
public slots:
    void closeWindow()
    { destroy(1,1);	}
public:
    QListBox *lista1;
    QPushButton *ok;
    QLabel *msg;
};

#endif // TK_QT_TEST_W

#endif // USE_GTK
